/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/**
 * Copyright (c) 2014-2018, Regents of the University of California
 *
 * This file is part of NAC (Name-Based Access Control for NDN).
 * See AUTHORS.md for complete list of NAC authors and contributors.
 *
 * NAC is free software: you can redistribute it and/or modify it under the terms
 * of the GNU General Public License as published by the Free Software Foundation,
 * either version 3 of the License, or (at your option) any later version.
 *
 * NAC is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * NAC, e.g., in COPYING.md file.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @author Yingdi Yu <yingdi@cs.ucla.edu>
 */

#ifndef NDN_NAC_ERROR_CODE_HPP
#define NDN_NAC_ERROR_CODE_HPP

#include "common.hpp"

namespace ndn {
namespace nac {

enum class ErrorCode {
  Timeout = 1,
  Validation = 2,
  UnsupportedEncryptionScheme = 32,
  InvalidEncryptedFormat = 33,
  NoDecryptKey = 34,
  EncryptionFailure = 35,
  DataRetrievalFailure = 36
};

using ErrorCallBack = std::function<void (const ErrorCode&, const std::string&)>;

} // namespace nac
} // namespace ndn

#endif // NDN_NAC_ERROR_CODE_HPP
